Index: cprs/trunk/CPRS-Chart/fGraphs.pas
===================================================================
--- cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 456)
+++ cprs/trunk/CPRS-Chart/fGraphs.pas	(revision 830)
@@ -3996,67 +4965,120 @@
 procedure TfrmGraphs.SetProfile(aProfile, aName: string; aListView: TListView);
 var
-  i, j: integer;
+  i: integer;
+  itemstring: string;
+  aGraphItem: TGraphItem;
+begin
+  aListView.Items.BeginUpdate;
+  if aProfile = '0' then
+    for i := 0 to aListView.Items.Count - 1 do
+      aListView.Items[i].SubItems[1] := ''
+  else
+    for i := 0 to aListView.Items.Count - 1 do
+    begin
+      aGraphItem := TGraphItem(aListView.Items.Item[i].SubItems.Objects[3]);   //get file^ien match
+      itemstring := aGraphItem.Values;
+      aListView.Items[i].SubItems[1] := ProfileName(aProfile, aName, itemstring);
+    end;
+  aListView.Items.EndUpdate;
+end;
+
+function TfrmGraphs.ProfileName(aProfile, aName, aString: string): string;
+var
+  j: integer;
   dcnm, itemdrugclass, itempart, itempart1, itempart2, itemnums: string;
-  itemstring, itemstring1, itemstringnums, profname: string;
-  aGraphItem: TGraphItem;
-begin
-  if aProfile = '0' then
-  for i := 0 to aListView.Items.Count - 1 do
-    aListView.Items[i].SubItems[1] := ''
-  else
-  for i := 0 to aListView.Items.Count - 1 do
-  begin
-    profname := '';
-    aGraphItem := TGraphItem(aListView.Items.Item[i].SubItems.Objects[3]);   //get file^ien match
-    itemstring := aGraphItem.Values;
-    itemstring1 := UpperCase(Piece(itemstring, '^', 1));
-    itemdrugclass := Piece(itemstring, '^', 6);
-    itemstringnums := UpperCase(Pieces(itemstring, '^', 1, 2));
-    for j := 1 to BIG_NUMBER do
-    begin
-      itempart := Piece(aProfile, '|', j);
-      if itempart = '' then break;
-      itempart1 := Piece(itempart, '~', 1);
-      itempart2 := Piece(itempart, '~', 2);
-      itemnums := itempart1 + '^' + itempart2;
-      if (itempart1 = '50.605') and (length(itemdrugclass) > 0) then
+  itemstring1, itemstringnums: string;
+begin
+  Result := '';
+  itemstring1 := UpperCase(Piece(aString, '^', 1));
+  itemdrugclass := Piece(aString, '^', 6);
+  itemstringnums := UpperCase(Pieces(aString, '^', 1, 2));
+  for j := 1 to BIG_NUMBER do
+  begin
+    itempart := Piece(aProfile, '|', j);
+    if itempart = '' then
+      break;
+    itempart1 := Piece(itempart, '~', 1);
+    itempart2 := Piece(itempart, '~', 2);
+    itemnums := itempart1 + '^' + itempart2;
+    if (itempart1 = '50.605') and (length(itemdrugclass) > 0) then
+    begin
+      dcnm := DCName(itempart2);
+      if dcnm = itemdrugclass then
       begin
-        dcnm := DCName(itempart2);
-        if dcnm = itemdrugclass then
-        begin
-          profname := aName;
-          break;
-        end;
-      end
-      else if itempart1 = '63' then
-      begin
-        if itemnums = Piece(itemstringnums, '.', 1) then
-        begin
-          profname := aName;
-          break;
-        end;
-      end
-      else
-      begin
-        if itemnums = itemstringnums then
-        begin
-          profname := aName;
-          break;
-        end;
-      end;
-      if (itempart1 = '0') and (itempart2 = itemstring1) then
-      begin
-        profname := aName;
-        break;
-      end
-      else if (itempart1 = '0') and (length(Piece(itempart2, ';', 2)) > 0) then    // subtypes
-      if copy(itempart2, 1, length(itemstring1)) = Piece(itempart2, ';', 1) then
-      if Piece(itempart2, ';', 2) = UpperCase(Piece(Piece(itemstring, '^', 2), ';', 2)) then
-      begin
-        profname := aName;
+        Result := aName;
         break;
       end;
-    end;
-    aListView.Items[i].SubItems[1] := profname;
+    end
+    else if itempart1 = '63' then
+    begin
+      if itemnums = Piece(itemstringnums, '.', 1) then
+      begin
+        Result := aName;
+        break;
+      end;
+    end
+    else
+    begin
+      if itemnums = itemstringnums then
+      begin
+        Result := aName;
+        break;
+      end;
+    end;
+    if (itempart1 = '0') and (itempart2 = itemstring1) then
+    begin
+      Result := aName;
+      break;
+    end
+    else if (itempart1 = '0') and (length(Piece(itempart2, ';', 2)) > 0) then    // subtypes
+    if copy(itempart2, 1, length(itemstring1)) = Piece(itempart2, ';', 1) then
+    if Piece(itempart2, ';', 2) = UpperCase(Piece(Piece(aString, '^', 2), ';', 2)) then
+    begin
+      Result := aName;
+      break;
+    end;
+  end;
+end;
+
+procedure TfrmGraphs.ViewDefinition(profile: string; amemo: TRichEdit);
+var
+  i, defnum: integer;
+  vname, vdef, vlist, vtype, vnum: string;
+begin
+  vtype := Piece(profile, '^', 1);
+  defnum := strtointdef(vtype, BIG_NUMBER);
+  vname := Piece(profile, '^', 2);
+  case defnum of
+    -1:  vdef := 'Personal View';
+    -2:  vdef := 'Public View';
+    -3:  vdef := 'Lab Group';
+    else vdef := 'Temporary View';
+  end;
+  amemo.Clear;
+  amemo.Lines.Add(vname + ' [' + vdef + ']:');
+  if vdef = 'Temporary View' then
+  begin
+    for i := 4 to BIG_NUMBER do
+    begin
+      vlist := Piece(profile, '^', i);
+      if vlist = '' then break;
+      amemo.Lines.Add('  ' + vlist);
+    end;
+  end
+  else
+  begin
+    vnum := '';
+    for i := 0 to GtslAllViews.Count - 1 do
+    begin
+      vlist := GtslAllViews[i];
+      if Piece(vlist, '^', 4) = vname then
+        if Piece(vlist, '^', 1) = vtype then
+          if Piece(vlist, '^', 2) = 'V' then
+            vnum := Piece(vlist, '^', 3);
+      if vnum <> '' then
+        if Piece(vlist, '^', 2) = 'C' then
+           if Piece(vlist, '^', 3) = vnum then
+             amemo.Lines.Add('   ' + Piece(vlist, '^', 4));
+    end;
   end;
 end;
@@ -4081,5 +5103,5 @@
     if length(itempart) = 0 then break;
     if Pos('811.2~', itempart) = 0 then
-      newprofile := newprofile + '|'
+      newprofile := newprofile + itempart + '|'
     else
       taxonomies.Add(itempart);
@@ -4114,15 +5136,25 @@
   itempart, itempart1, itempart2, profile, profilename, profiletype, xprofile: string;
 begin
+  Application.ProcessMessages;
+  GtslTemp.Clear;
   profiletype := Piece(aProfile, '^', 1);
   profilename := Piece(aProfile, '^', 2);
-  if profiletype = '-2' then
-    FastAssign(rpcGetGraphProfiles(UpperCase(profilename), '1', 0), lstTemp.Items)
-  else if profiletype = '-1' then
-    FastAssign(rpcGetGraphProfiles(UpperCase(profilename), '0', 0), lstTemp.Items);
+  if profiletype = VIEW_PUBLIC then
+    FastAssign(GetGraphProfiles(UpperCase(profilename), '1', 0, 0), GtslTemp)
+  else if profiletype = VIEW_PERSONAL then
+    FastAssign(GetGraphProfiles(UpperCase(profilename), '0', 0, User.DUZ), GtslTemp)
+  else if profiletype = VIEW_LABS then
+  begin
+    FastAssign(GetATestGroup(strtoint(Piece(aProfile, '^', 3)), strtoint(Piece(aProfile, '^', 4))), GtslTemp);
+    aProfile := VIEW_LABS + '^' + Piece(aProfile, '^', 2) + '^';
+    for i := 0 to GtslTemp.Count - 1 do
+      aProfile := aProfile + '63~' + Piece(GtslTemp[i], '^', 1) + '~|';
+    GtslTemp.Clear;
+  end;
   if profiletype <> '' then
   begin
-    for i := 0 to lstTemp.Items.Count - 1 do
-      aProfile := aProfile + lstTemp.Items[i];
-    lstTemp.Items.Clear;
+    for i := 0 to GtslTemp.Count - 1 do
+      aProfile := aProfile + GtslTemp[i];
+    GtslTemp.Clear;
   end;
   Updated := false;
@@ -4152,5 +5184,4 @@
       LoadDisplayCheck('52', Updated);
       LoadDisplayCheck('55', Updated);
-      //LoadDisplayCheck('55NVAE', Updated);     // nonvameds as events are not being used
       LoadDisplayCheck('55NVA', Updated);
       LoadDisplayCheck('53.79', Updated);
@@ -4163,4 +5194,8 @@
 procedure TfrmGraphs.LoadDisplayCheck(typeofitem: string; var Updated: boolean);
 begin
+  if FFastTrack then
+  begin
+    exit;
+  end;
   if not TypeIsLoaded(typeofitem) then
   begin
@@ -4197,4 +5232,10 @@
     else if aListView = lvwItemsBottom then
       lvwItemsBottom.ClearSelection;
+    if FTooManyItems then FTooManyItems := false
+    else
+    begin
+      ShowMsg('Too many items to graph');
+      FTooManyItems := true;  // flag so that warning will not be displayed twice
+    end;
   end;
   if aListView = lvwItemsTop then
@@ -4204,148 +5245,165 @@
 end;
 
-procedure TfrmGraphs.LabData(aItemType, aItemName, aSection: string);
-var
-  singlespec: boolean;
-  i, oldlisting: integer;
-  checkitem, checkstring, datastring, filename, itemnum, newitemname, newitemnum, newstring: string;
-  spec1, spec2, spec3, spec4: string;
+procedure TfrmGraphs.SpecCheck(var spec1, spec2, spec3, spec4: string; var singlespec: boolean);
+var
+  i: integer;
+  checkstring, datastring: string;
+begin
+  singlespec := true;
+  spec1 := ''; spec2 := ''; spec3 := ''; spec4 := '';
+  GtslSpec1.Clear; GtslSpec2.Clear; GtslSpec3.Clear; GtslSpec4.Clear;
+  for i := 0 to GtslScratchLab.Count - 1 do
+  begin
+    datastring := GtslScratchLab[i];
+    checkstring := Pieces(datastring, '^', 1, 2) + '^' + Pieces(datastring, '^', 7, 8);
+    if length(spec1) = 0  then
+    begin
+      spec1 := checkstring;
+      GtslSpec1.Add(datastring)
+    end
+    else if spec1 = checkstring then
+      GtslSpec1.Add(datastring)
+    else if length(spec2) = 0 then
+    begin
+      singlespec := false;
+      spec2 := checkstring;
+      GtslSpec2.Add(datastring)
+    end
+    else if spec2 = checkstring then
+      GtslSpec2.Add(datastring)
+    else if length(spec3) = 0 then
+    begin
+      spec3 := checkstring;
+      GtslSpec3.Add(datastring)
+    end
+    else if spec3 = checkstring then
+      GtslSpec3.Add(datastring)
+    else
+    begin
+      spec4 := checkstring;
+      GtslSpec4.Add(datastring)
+    end;
+  end;
+end;
+
+procedure TfrmGraphs.SpecSet(var spec1, spec2, spec3, spec4: string; aItemType, aItemName: string);
+var
+  i: integer;
+  itemnum, newitemname, newitemnum, newstring: string;
+begin
+  GtslMultiSpec.Clear;
+  itemnum := Piece(aItemType, '^', 2);
+  if length(spec1) > 0 then
+  begin
+    newitemnum := itemnum + '.1';
+    newitemname := aItemName + ' (' + LowerCase(Piece(spec1, '^', 4)) + ')';
+    for i := 0 to GtslItems.Count - 1 do
+    if aItemType = Pieces(GtslItems[i], '^', 1, 2) then
+    begin
+      newstring := GtslItems[i];
+      GtslItems.Delete(i);
+      break;
+    end;
+    for i := 0 to GtslData.Count - 1 do
+    if aItemType = Pieces(GtslData[i], '^', 1, 2) then
+      GtslData.Delete(i);
+    ResetSpec(GtslSpec1, itemnum, newitemnum, newitemname, newstring);
+  end;
+  if length(spec2) > 0 then
+  begin
+    newitemnum := itemnum + '.2';
+    newitemname := aItemName + ' (' + LowerCase(Piece(spec2, '^', 4)) + ')';
+    ResetSpec(GtslSpec2, itemnum, newitemnum, newitemname, newstring);
+  end;
+  if length(spec3) > 0 then
+  begin
+    newitemnum := itemnum + '.3';
+    newitemname := aItemName + ' (' + LowerCase(Piece(spec3, '^', 4)) + ')';
+    ResetSpec(GtslSpec3, itemnum, newitemnum, newitemname, newstring);
+  end;
+  if length(spec4) > 0 then
+  begin
+    newitemnum := itemnum + '.4';
+    newitemname := aItemName + ' (other)';     // not specific after 3 specimens (from same time)
+    ResetSpec(GtslSpec4, itemnum, newitemnum, newitemname, newstring);
+  end;
+end;
+
+procedure TfrmGraphs.LabAdd(aListView: TListView; filename: string; aIndex, oldlisting: integer; selectlab: boolean);
+var
   aGraphItem: TGraphItem;
   aListItem: TListItem;
 begin
-  singlespec := true;
-  spec1 := ''; spec2 := ''; spec3 := ''; spec4 := '';
-  lstSpec1.Items.Clear; lstSpec2.Items.Clear; lstSpec3.Items.Clear; lstSpec4.Items.Clear;
-  FastAssign(rpcGetItemData(aItemType, FMTimeStamp, Patient.DFN), lstScratchLab.Items);
-  for i := 0 to lstScratchLab.Items.Count - 1 do
-  begin
-    datastring := lstScratchLab.Items[i];
-    checkstring := Pieces(datastring, '^', 1, 2) + '^' + Pieces(datastring, '^', 7, 8);
-    if length(spec1) = 0  then
-    begin
-      spec1 := checkstring;
-      lstSpec1.Items.Add(datastring)
-    end
-    else if spec1 = checkstring then
-      lstSpec1.Items.Add(datastring)
-    else if length(spec2) = 0 then
-    begin
-      singlespec := false;
-      spec2 := checkstring;
-      lstSpec2.Items.Add(datastring)
-    end
-    else if spec2 = checkstring then
-      lstSpec2.Items.Add(datastring)
-    else if length(spec3) = 0 then
-    begin
-      spec3 := checkstring;
-      lstSpec3.Items.Add(datastring)
-    end
-    else if spec3 = checkstring then
-      lstSpec3.Items.Add(datastring)
-    else
-    begin
-      spec4 := checkstring;
-      lstSpec4.Items.Add(datastring)
-    end;
-  end;
+  aListItem := aListView.Items.Insert(oldlisting);
+  aListItem.Caption := Piece(GtslMultiSpec[aIndex], '^', 4);
+  aListItem.SubItems.Add(filename);
+  aListItem.SubItems.Add('');
+  aListItem.SubItems.Add('');
+  aGraphItem := TGraphItem.Create;
+  aGraphItem.Values := GtslMultiSpec[aIndex];
+  aListItem.SubItems.AddObject('', aGraphItem);
+  if selectlab then
+    if not FFastLabs then
+      aListView.Items[oldlisting].Selected := true;
+end;
+
+procedure TfrmGraphs.LabCheck(aListView: TListView; aItemType: string; var oldlisting: integer);
+var
+  i: integer;
+  checkitem: string;
+  aGraphItem: TGraphItem;
+begin
+  oldlisting := 0;
+  aListView.SortType := stNone;    // avoids out of bounds error
+  for i := 0 to aListView.Items.Count - 1 do
+  begin
+    aGraphItem := TGraphItem(aListView.Items.Item[i].SubItems.Objects[3]);   //get file^ien match
+    checkitem := Pieces(aGraphItem.Values, '^', 1, 2);
+    if aItemType = checkitem then
+    begin
+      oldlisting := i;
+      aListView.Items.Delete(i);
+      break;
+    end;
+  end;
+end;
+
+procedure TfrmGraphs.LabData(aItemType, aItemName, aSection: string; getdata: boolean);
+var
+  singlespec, selectlab: boolean;
+  i, oldlisting: integer;
+  filename: string;
+  spec1, spec2, spec3, spec4: string;
+begin
+  if getdata then
+    FastAssign(rpcGetItemData(aItemType, FMTimeStamp, Patient.DFN), GtslScratchLab);
+  SpecCheck(spec1, spec2, spec3, spec4, singlespec);
   if singlespec then
-    lstData.Items.AddStrings(lstScratchLab.Items)
+    FastAddStrings(GtslScratchLab, GtslData)
   else
   begin
-    lstMultiSpec.Items.Clear;
-    itemnum := Piece(aItemType, '^', 2);
-    if length(spec1) > 0 then
-    begin
-      newitemnum := itemnum + '.1';
-      newitemname := aItemName + ' (' + LowerCase(Piece(spec1, '^', 4)) + ')';
-      for i := 0 to lstItems.Items.Count - 1 do
-      if aItemType = Pieces(lstItems.Items[i], '^', 1, 2) then
-      begin
-        newstring := lstItems.Items[i];
-        lstItems.Items.Delete(i);
-        break;
-      end;
-      for i := 0 to lstData.Items.Count - 1 do
-      if aItemType = Pieces(lstData.Items[i], '^', 1, 2) then
-        lstData.Items.Delete(i);
-      ResetSpec(lstSpec1, itemnum, newitemnum, newitemname, newstring);
-    end;
-    if length(spec2) > 0 then
-    begin
-      newitemnum := itemnum + '.2';
-      newitemname := aItemName + ' (' + LowerCase(Piece(spec2, '^', 4)) + ')';
-      ResetSpec(lstSpec2, itemnum, newitemnum, newitemname, newstring);
-    end;
-    if length(spec3) > 0 then
-    begin
-      newitemnum := itemnum + '.3';
-      newitemname := aItemName + ' (' + LowerCase(Piece(spec3, '^', 4)) + ')';
-      ResetSpec(lstSpec3, itemnum, newitemnum, newitemname, newstring);
-    end;
-    if length(spec4) > 0 then
-    begin
-      newitemnum := itemnum + '.4';
-      newitemname := aItemName + ' (other)';     // not specific after 3 specimens (from same time)
-      ResetSpec(lstSpec4, itemnum, newitemnum, newitemname, newstring);
-    end;
-    oldlisting := 0;
-    lvwItemsTop.SortType := stNone;    // avoids out of bounds error
-    for i := 0 to lvwItemsTop.Items.Count - 1 do
-    begin
-      aGraphItem := TGraphItem(lvwItemsTop.Items.Item[i].SubItems.Objects[3]);   //get file^ien match
-      checkitem := Pieces(aGraphItem.Values, '^', 1, 2);
-      if aItemType = checkitem then
-      begin
-        oldlisting := i;
-        lvwItemsTop.Items.Delete(i);
-        break;
-      end;
-    end;
+    SpecSet(spec1, spec2, spec3, spec4, aItemType, aItemName);
     filename := FileNameX('63');
-    for i := 0 to lstMultiSpec.Items.Count - 1 do
-    begin
-      lstCheck.Items.Add(UpperCase(Pieces(lstMultiSpec.Items[i], '^', 1, 2)));
-      if (FGraphSetting.FMStartDate = FM_START_DATE)
-        or DateRangeMultiItems(FGraphSetting.FMStartDate, FGraphSetting.FMStopDate, Piece(lstMultiSpec.Items[i], '^', 2)) then
-      begin
-      with lvwItemsTop do
-        aListItem := Items.Insert(oldlisting);
-        aListItem.Caption := Piece(lstMultiSpec.Items[i], '^', 4);
-        aListItem.SubItems.Add(filename);
-        aListItem.SubItems.Add('');
-        aListItem.SubItems.Add('');
-        aGraphItem := TGraphItem.Create;
-        aGraphItem.Values := lstMultiSpec.Items[i];
-        aListItem.SubItems.AddObject('info object', aGraphItem);
-        if aSection = 'top' then lvwItemsTop.Items[oldlisting].Selected := true;
-      end;
+
+    LabCheck(lvwItemsTop, aItemType, oldlisting);
+    selectlab := aSection = 'top';
+    lvwItemsTop.Items.BeginUpdate;
+    for i := 0 to GtslMultiSpec.Count - 1 do
+    begin
+      GtslCheck.Add(UpperCase(Pieces(GtslMultiSpec[i], '^', 1, 2)));
+      if (FGraphSetting.FMStartDate = FM_START_DATE) or
+          DateRangeMultiItems(FGraphSetting.FMStartDate, FGraphSetting.FMStopDate, Piece(GtslMultiSpec[i], '^', 2)) then
+        LabAdd(lvwItemsTop, filename, i, oldlisting, selectlab);
     end;
     lvwItemsTop.SortType := stBoth;
-    oldlisting := 0;
-    lvwItemsBottom.SortType := stNone;    // avoids out of bounds error
-    for i := 0 to lvwItemsBottom.Items.Count - 1 do
-    begin
-      aGraphItem := TGraphItem(lvwItemsBottom.Items.Item[i].SubItems.Objects[3]);   //get file^ien match
-      checkitem := Pieces(aGraphItem.Values, '^', 1, 2);
-      if aItemType = checkitem then
-      begin
-        oldlisting := i;
-        lvwItemsBottom.Items.Delete(i);
-        break;
-      end;
-    end;
-    for i := 0 to lstMultiSpec.Items.Count - 1 do
-    begin
-      aListItem := lvwItemsBottom.Items.Insert(oldlisting);
-      aListItem.Caption := Piece(lstMultiSpec.Items[i], '^', 4);
-      aListItem.SubItems.Add(filename);
-      aListItem.SubItems.Add('');
-      aListItem.SubItems.Add('');
-      aGraphItem := TGraphItem.Create;
-      aGraphItem.Values := lstMultiSpec.Items[i];
-      aListItem.SubItems.AddObject('info object', aGraphItem);
-      if aSection = 'bottom' then lvwItemsBottom.Items[oldlisting].Selected := true;
-    end;
+    lvwItemsTop.Items.EndUpdate;
+
+    LabCheck(lvwItemsBottom, aItemType, oldlisting);
+    selectlab := aSection = 'bottom';
+    lvwItemsBottom.Items.BeginUpdate;
+    for i := 0 to GtslMultiSpec.Count - 1 do
+      LabAdd(lvwItemsBottom, filename, i, oldlisting, selectlab);
     lvwItemsBottom.SortType := stBoth;
+    lvwItemsBottom.Items.EndUpdate;
   end;
 end;
@@ -4364,8 +5422,8 @@
   end;
   itemspec := aItem + '^' + aSpec;
-  for i := 0 to lstTestSpec.Items.Count - 1 do
-  if itemspec = Pieces(lstTestSpec.Items[i], '^', 1, 2) then
-  begin
-    specstring := lstTestSpec.Items[i];
+  for i := 0 to GtslTestSpec.Count - 1 do
+  if itemspec = Pieces(GtslTestSpec[i], '^', 1, 2) then
+  begin
+    specstring := GtslTestSpec[i];
     low :=   Piece(specstring, '^', 3);
     high :=  Piece(specstring, '^', 4);
@@ -4442,5 +5500,5 @@
 end;
 
-procedure TfrmGraphs.ResetSpec(aListBox: TListBox; aItemNum, aNewItemNum, aNewItemName, aNewString: string);
+procedure TfrmGraphs.ResetSpec(aList: TStrings; aItemNum, aNewItemNum, aNewItemName, aNewString: string);
 var                                             //also add itemx
   i: integer;
@@ -4448,22 +5506,22 @@
   newestdate, newstring: string;
 begin
-  lstTemp.Items.Clear;
+  GtslTemp.Clear;
   newdate := 0;
-  for i := 0 to aListBox.Items.Count - 1 do
-  begin
-    newstring := aListBox.Items[i];
+  for i := 0 to aList.Count - 1 do
+  begin
+    newstring := aList[i];
     newestdate := FMCorrectedDate(Piece(newstring, '^', 3));
     checkdate := strtofloatdef(newestdate, -BIG_NUMBER);
     if checkdate > newdate then newdate := checkdate;
     SetPiece(newstring, '^', 2, aNewItemNum);
-    lstTemp.Items.Add(newstring);
-  end;
-  lstData.Items.AddStrings(lstTemp.Items);
+    GtslTemp.Add(newstring);
+  end;
+  FastAddStrings(GtslTemp, GtslData);
   newestdate := floattostr(newdate);
   SetPiece(aNewString, '^', 2, aNewItemNum);
   SetPiece(aNewString, '^', 4, aNewItemName);
   SetPiece(aNewString, '^', 6, newestdate);
-  lstItems.Items.Add(aNewString);
-  lstMultiSpec.Items.Add(aNewString);
+  GtslItems.Add(aNewString);
+  GtslMultiSpec.Add(aNewString);
 end;
 
@@ -4492,4 +5550,6 @@
         mnuPopGraphRemove.Caption := 'Remove - ' + seriestitle;
         mnuPopGraphDetails.Caption := 'Details - ' + seriestitle;
+        mnuPopGraphValueMarks.Caption := 'Values - ';
+        mnuPopGraphValueMarks.Enabled := false;
       end
       else
@@ -4511,4 +5571,6 @@
         mnuPopGraphRemove.Caption := 'Remove - ' + seriestitle;
         mnuPopGraphDetails.Caption := 'Details - ' + seriestitle;
+        mnuPopGraphValueMarks.Caption := 'Values - ';
+        mnuPopGraphValueMarks.Enabled := false;
       end
       else
@@ -4530,7 +5592,7 @@
   fmdatetime := datetimetofmdatetime(aDateTime);
   fmstring := floattostr(fmdatetime);
-  for i := 0 to lstData.Items.Count - 1 do
-  begin
-    datastring := lstData.Items[i];
+  for i := 0 to GtslData.Count - 1 do
+  begin
+    datastring := GtslData[i];
     if Pieces(datastring, '^', 1, 2) = '120.5^1' then   //********** get item # for bp instead of 1
     begin
@@ -4547,9 +5609,19 @@
 end;
 
-procedure TfrmGraphs.mnuMedsasganttClick(Sender: TObject);
-begin
-  (Sender as TMenuItem).Checked := true;
-  lvwItemsTopClick(self);
-  lvwItemsBottomClick(self);
+procedure TfrmGraphs.mnuCustomClick(Sender: TObject);
+begin
+  mnuCustom.Checked := not mnuCustom.Checked;
+  tsTopCustom.TabVisible := mnuCustom.Checked;
+  tsBottomCustom.TabVisible := mnuCustom.Checked;
+end;
+
+procedure TfrmGraphs.mnuGraphDataClick(Sender: TObject);
+begin
+  frmGraphData.Show;
+end;
+
+procedure TfrmGraphs.mnuMHasNumeric1Click(Sender: TObject);
+begin
+  DialogGraphOthers(1);
 end;
 
@@ -4557,5 +5629,5 @@
 begin
   FFirstClick := true;
-  lstZoomHistory.Items.Clear;
+  GtslZoomHistoryFloat.Clear;
   FRetainZoom := false;
   mnuPopGraphZoomBack.Enabled := false;
@@ -4566,40 +5638,50 @@
   ValueIndex: Integer; var MarkText: String);
 var
-  cnt, i: integer;
-  checktag, nonstring: string;
-begin    // ********* listing one series' values is ok but no multiple ???
+  i: integer;
+  checktag, checkindex, checkseries, firstdatecheck, firsttext, nonstring: string;
+begin
+  firsttext := MarkText;
   MarkText := Sender.Title;
-  if Copy(MarkText, 1, 4) = 'Ref ' then
-    MarkText := '';
-  if Sender.Title = '(non-numeric)' then
+  if Copy(MarkText, 1, 4) = 'Ref ' then MarkText := ''
+  else if Piece(Sender.Title, '^', 1) = '(non-numeric)' then
   begin
     if Sender.Tag > 0 then
     begin
-      checktag := inttostr(Sender.Tag);
-      cnt := -1;
-      for i := 0 to lstNonNumeric.Items.Count - 1 do
+      checkseries := inttostr(Sender.Tag - BIG_NUMBER);
+      firstdatecheck := floattostr(sender.XValue[ValueIndex]);
+      checktag := inttostr(Sender.ParentChart.Tag);
+      checkindex := inttostr(ValueIndex + 1);
+      for i := 0 to GtslNonNum.Count - 1 do
       begin
-        nonstring := lstNonNumeric.Items[i];
-        if  checktag = Piece(nonstring, '^', 3) then
+        nonstring := GtslNonNum[i];
+        if checktag = '0' then
         begin
-          cnt := cnt + 1;
-          if  cnt = ValueIndex then
+          if checkseries = Piece(nonstring, '^', 3) then
+            if Piece(nonstring, '^', 4) = checkindex then
+            begin
+              MarkText := Piece(nonstring, '^', 13);
+            end;
+        end
+        else if checktag = Piece(nonstring, '^', 2) then
+        begin
+          if checkseries = Piece(nonstring, '^', 3) then
+          if Piece(nonstring, '^', 4) = checkindex then
           begin
-            MarkText := Piece(nonstring, '^', 2);
+            MarkText := Piece(nonstring, '^', 13);
             break;
           end;
         end;
       end;
-      if MarkText = '(non-numeric)' then
-        beep;
-    end;
-  end;
+    end;
+  end
+  else if Sender is TLineSeries then
+    MarkText := firsttext;   
 end;
 
 procedure TfrmGraphs.mnuPopGraphRemoveClick(Sender: TObject);
 var
-  i, selnum: integer;
+  selnum: integer;
   aSection, typeitem: string;
-  aComboBox: TORComboBox;
+  aListBox: TORListBox;
   aListView: TListView;
 begin
@@ -4607,5 +5689,5 @@
   if pnlTop.Tag = 1 then
   begin
-    aComboBox := cboViewsTop;
+    aListBox := lstViewsTop;
     aListView := lvwItemsTop;
     aSection := 'top';
@@ -4613,22 +5695,12 @@
   else
   begin
-    aComboBox := cboViewsBottom;
+    aListBox := lstViewsBottom;
     aListView := lvwItemsBottom;
     aSection := 'bottom';
   end;
-  aComboBox.ItemIndex := -1;
-  aComboBox.Text := '';
+  aListBox.ItemIndex := -1;
   if aListView.SelCount = 0 then exit;
   if StripHotKey(mnuPopGraphRemove.Caption) = ('Remove all selections from ' + aSection) then
-  begin
-    with aListView do
-    for i := 0 to Items.Count - 1 do
-      if Items[i].Selected then
-      begin
-        Items[i].Selected := false;
-      end;
-    DisplayData('top');
-    DisplayData('bottom');
-  end
+    aListView.Selected := nil
   else
   begin
@@ -4636,7 +5708,7 @@
     if selnum = -1 then exit;
     aListView.Items[selnum].Selected := false;
-    DisplayData('top');
-    DisplayData('bottom');
-  end;
+  end;
+  DisplayData('top');
+  DisplayData('bottom');
   mnuPopGraphRemove.Enabled := false;
   mnuPopGraphResetClick(self);
@@ -4656,4 +5728,5 @@
   displayheight, displaynum, i: integer;
 begin
+  if Not Assigned(FGraphSetting) then Exit;
   ChartOnZoom(chartDatelineTop);
   with aScrollBox do
